function Fl_th = Load_Fl(dir,Nfloors,Npoints);
global  flnFl
% This function loads the floor load time series
%%%%%%%%%%% Floor load time series: flnfl, Page 2, [Nfloor x Npoints] %%%%%%%%%%%
% Load 'flnFl' and check for errors
flnFlx = ([flnFl(1:end-3)]);
if dir<10
    dir3 = ['00' num2str(dir)];
else if dir<100
    dir3 = ['0' num2str(dir)];
else
    dir3 = num2str(dir);
end; end
clear fid; fid=fopen([flnFlx  dir3 '.mat']);
if fid == -1
    errordlg('Unable to open ''flnFl'' - Page 2')
    error   ('Unable to open ''flnFl'' - Page 2')
end
fclose(fid); clear fid;

[Fl_th]=[]; 
load ([flnFlx  dir3]);
s = who('F*');
eval(['Fl_th = ' s{1} ';']);
if size(Fl_th,1) == Npoints
    Fl_th = Fl_th';
end

if isempty(Fl_th)==1
    errordlg(['Variable ''Fl_th'' not defined for direction '  dir3  ' degrees. See flnFl '...
              'on Page Two'])
    error   (['Variable ''Fl_th'' not defined for direction '  dir3  ' degrees. See flnFl '...
              'on Page Two'])
end
if size(Fl_th,1) ~= 3*Nfloors | size(Fl_th,2) ~= Npoints
    errordlg(['Variable ''Fl_th'' not properly sized for direction '  dir3  ' degrees. '...
              '(Nfloors x Npoints)'])
    error   (['Variable ''Fl_th'' not properly sized for direction '  dir3  ' degrees. '...
              '(Nfloors x Npoints'])
end